# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import playerlib
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')
admins = es.import_addon('sam/base/manager')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Admins Chat'
addon.basename = 'adminschat'
addon.status   = 1
addon.version  = '1.3.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# * VARIABLES

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

	### Filter ###
	es.addons.registerSayFilter(chatFilter)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)
	
	### Filter ###
	es.addons.unregisterSayFilter(chatFilter)

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def chatFilter(userid, text, teamonly):
	text = text.strip('"')
	if admins.isAdmin(es.getplayersteamid(userid)):
		if admins.checkAccess(es.getplayersteamid(userid), 'Admin Chat'):
			if text.startswith('###'):
				func.centertell('all', 'ADMIN: %s' % text.strip('##').strip(' '))
				return (0, 0, 0)
			if text.startswith('##'):
				func.say('#all', '#DimGrey[ GLOBAL CHAT ] : #white%s' % text.strip('#').strip(' '))
				return (0, 0, 0)
			elif text.startswith('#'):
				if not teamonly: func.say('#all', '#DimGrey[ ADMIN ] #LightSlateGrey%s #DimGrey: #white%s' % (es.getplayername(userid),text.strip('#').strip(' ')))
				elif teamonly:
					for ply in playerlib.getPlayerList('#human'):
						if admins.isAdmin(ply.steamid): func.say(ply, '#DarkGreen[ ADMINS CHAT ] #lightgreen%s #DarkGreen: #green%s' % (es.getplayername(userid),text.strip('#').strip(' ')))
				return (0, 0, 0)
			else: return (userid, text, teamonly)
	else:
		if text.startswith('#'):
			for ply in playerlib.getPlayerList('#human'):
				if admins.isAdmin(ply.steamid): func.say(ply, '#LawnGreen%s to Admins : #lightgreen%s' % (es.getplayername(userid),text.strip('#').strip(' ')))
				func.say(userid, '#LawnGreenYou to Admins : #lightgreen%s' % text.strip('#').strip(' '))
			return (0, 0 ,0)
		else: return (userid, text, teamonly)

# ============================================================================================================================================================= #