# MAIN IMPORTS ================================================================================================================================================ #
import psyco
psyco.full()
import es
import gamethread
# ============================================================================================================================================================= #

# * SAM IMPORTS
func   = es.import_addon('sam/functions')

# '''''''''''''''''''' # Addon/Mod Info # '''''''''''''''''' #
addon = es.AddonInfo()
addon.name     = 'Bomb Timer'
addon.basename = 'bombtimer'
addon.status   = 0
addon.version  = '1.0.pub'
# '''''''''''''''''''''''''''''''''''''''''''''''''''''''''' #

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Addon State ###
	es.set('sam_' + addon.basename, 1)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Addon State ###
	es.set('sam_' + addon.basename, 0)

	### Cancel Delay ###
	gamethread.cancelDelayed('sam_bomb_timer')

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def loop(sec):
	func.hudhint2('#all', '## %s ##\n%s\n%s' % (func.lang_addon(addon.basename, 'planted'),'-'*20,func.lang_addon(addon.basename, 'timeleft', {'secs':sec})))
	if sec != 0: gamethread.delayedname( 1, 'sam_bomb_timer', loop, (sec - 1))
	else: func.hudhint2('#all', '## %s ##' % func.lang_addon(addon.basename, 'exploded'))

# ============================================================================================================================================================= #
# ========================================================================= EVENTS ============================================================================ #
# ============================================================================================================================================================= #
def bomb_planted(ev): loop(int(es.ServerVar('mp_c4timer')))

# ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def bomb_defused(ev):
	func.hudhint2('#all', '## %s ##' % func.lang_addon(addon.basename, 'defused'))
	gamethread.cancelDelayed('sam_bomb_timer')

# ============================================================================================================================================================= #