# MAIN IMPORTS ================================================================================================================================================ #
from __future__ import with_statement
import psyco
psyco.full()
import es
import cfglib
import gamethread
import os
# ============================================================================================================================================================= #

# * SAM IMPORTS
func = es.import_addon('sam/functions')

# * VARIABLES

addonscfg   = 'cstrike/cfg/sam/addons_configs/'
cfgfile     = 'cstrike/cfg/sam/config.cfg'
reasonsfile = 'cstrike/cfg/sam/reasons.txt'

# ============================================================================================================================================================= #
# ========================================================================== LOAD ============================================================================= #
# ============================================================================================================================================================= #
def load():
	### Files Blocks ###
	createFiles()

	### Save CMDs to Cloud ###
	cloudSave()

	### Execute CMDs ###
	execCMDs(.1)

# ============================================================================================================================================================= #
# ========================================================================= UNLOAD ============================================================================ #
# ============================================================================================================================================================= #
def unload():
	### Cancel Delay ###
	gamethread.cancelDelayed('sam_execcmds_loop')

# ============================================================================================================================================================= #
# ======================================================================= MAIN BLOCKS ========================================================================= #
# ============================================================================================================================================================= #
def createFiles():
	if not os.path.isfile(cfgfile): ### MAIN CONFIG FILE ###
		cfg = cfglib.AddonCFG(cfgfile)
		cfg.text('-' * 80)
		cfg.text(' # Source Admin Menu | Configuration File')
		cfg.text('-' * 80)
		cfg.cvar('sam_language', func.lang, 'SAM language. [Available languages: English, Portuguese]')
		cfg.cvar('sam_menu_title', func.menutitle, 'Menu title.')
		cfg.cvar('sam_chat_tag', func.tag, 'Your community/team/group tag.')
		cfg.write()
	if not os.path.isfile(reasonsfile): ### REASONS FILE ###
		f = open(reasonsfile,'w')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write('#  Source Admin Menu # Reasons file  \n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write('#\n')
		f.write('#  This file contains all the reasons to be used when banning a player.\n')
		f.write('#\n')
		f.write('#  To add a reason follow this example:\n')
		f.write('#  EXP: "- You deserved it!"\n')
		f.write('#  Note: the - (eifen) must be there, or else it wont work.\n')
		f.write('#\n')
		f.write('# - - - - - - - - - - - - - - - - - -\n')
		f.write(' \n')
		f.write('- Disrespecting admins\n')
		f.write('- Disrespecting Server rules\n')
		f.write('- Chat spaming / Micro noise\n')
		f.write('- Cheating with Aimbot\n')
		f.write('- Cheating with SpeedHack\n')
		f.write('- Cheating with wallhack')

# ============================================================================================================================================================= #
# ======================================================================== FUNCTIONS ========================================================================== #
# ============================================================================================================================================================= #
def cloudSave():
	list = [addonscfg + item for item in os.listdir(addonscfg)]
	list.append(cfgfile)
	for path in list:
		with open(path) as f:
			for line in f.readlines():
				if line.startswith('   sam_'):
					line  = line.replace('   ','').split(' "')
					func.cloud['cmds'][line[0]] = line[1].strip('"')

# :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: #
def execCMDs(delay):
	cloudSave()
	for cmd in func.cloud['cmds']:
		if es.exists('command', cmd): es.server.queuecmd('%s "%s"' % (cmd,func.cloud['cmds'][cmd].strip('"')))
	gamethread.delayedname(delay, 'sam_execcmds_loop', execCMDs, (5))

# ============================================================================================================================================================= #